commit:     2edee4fe46bba8564962607cd1bdde14b201fd72
Author:     Andrew Ammerlaan <andrewammerlaan <AT> gentoo <DOT> org>
AuthorDate: Sat Apr  1 14:50:51 2023 +0000
Commit:     Andrew Ammerlaan <andrewammerlaan <AT> gentoo <DOT> org>
CommitDate: Sat Apr  1 14:51:25 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=2edee4fe

dev-python/shiboken6: add 6.4.3

Signed-off-by: Andrew Ammerlaan <andrewammerlaan <AT> gentoo.org>

 dev-python/shiboken6/Manifest               |   1 +
 dev-python/shiboken6/shiboken6-6.4.3.ebuild | 169 ++++++++++++++++++++++++++++
 2 files changed, 170 insertions(+)

diff --git a/dev-python/shiboken6/Manifest b/dev-python/shiboken6/Manifest
index 1f656317eec9..4626254b1a9d 100644
--- a/dev-python/shiboken6/Manifest
+++ b/dev-python/shiboken6/Manifest
@@ -1 +1,2 @@
+DIST pyside-setup-everywhere-src-6.4.3.tar.xz 8789448 BLAKE2B 
d9083bd636d3ccf2636b58385fffbc1499db0cbd80e199581e68a440c01b16acd440d7fdbaf41d8b4caa9974d31e457372ed7a80f1525929777d2265fe1297fe
 SHA512 
cc8051d52240b9aca531e3163523274334bfa339f2815ed46c4b4d09be2419f1f4cc6ebfc1e591658b5caccf840f8791333ea119c72a1e53591f1d8ca2e08baa
 DIST pyside-setup-opensource-src-6.4.2.tar.xz 8759528 BLAKE2B 
cc1a18e9dc81eb02bbfffd38816da68f053337f94c485fdd2f99488ae7ade2e899be1d98518def8f39a4eeaeaff6018ff09402bfe55b3484d78d8c4d9796b4e7
 SHA512 
129ea420000fceef9726fab9e0320e8286a34aa0855fc4bd369adc0020b76909b3a5ac8c3fa622b73da1561b39dcaeb8ac121f634918e2c0460a9ebaccb0f659

diff --git a/dev-python/shiboken6/shiboken6-6.4.3.ebuild 
b/dev-python/shiboken6/shiboken6-6.4.3.ebuild
new file mode 100644
index 000000000000..08626cfcf034
--- /dev/null
+++ b/dev-python/shiboken6/shiboken6-6.4.3.ebuild
@@ -0,0 +1,169 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+# TODO: Split the "/usr/bin/shiboken6" binding generator from the
+# "/usr/lib64/libshiboken6-*.so" family of shared libraries. The former
+# requires everything (including Clang) at runtime; the latter only requires
+# Qt and Python at runtime. Note that "pip" separates these two as well. See:
+# 
https://doc.qt.io/qtforpython/shiboken6/faq.html#is-there-any-runtime-dependency-on-the-generated-binding
+# Once split, the PySide6 ebuild should be revised to require
+# "/usr/bin/shiboken6" at build time and "libshiboken6-*.so" at runtime.
+# TODO: Add PyPy once officially supported. See also:
+#     https://bugreports.qt.io/browse/PYSIDE-535
+PYTHON_COMPAT=( python3_{9..11} )
+
+inherit cmake llvm python-r1 toolchain-funcs
+
+MY_PN="pyside-setup-everywhere-src"
+
+DESCRIPTION="Python binding generator for C++ libraries"
+HOMEPAGE="https://wiki.qt.io/PySide6";
+SRC_URI="https://download.qt.io/official_releases/QtForPython/pyside6/PySide6-${PV}-src/${MY_PN}-${PV}.tar.xz";
+S="${WORKDIR}/${MY_PN}-$(ver_cut 1-2)/sources/shiboken6"
+
+# The "sources/shiboken6/libshiboken" directory is triple-licensed under the
+# GPL v2, v3+, and LGPL v3. All remaining files are licensed under the GPL v3
+# with version 1.0 of a Qt-specific exception enabling shiboken6 output to be
+# arbitrarily relicensed. (TODO)
+LICENSE="|| ( GPL-2 GPL-3+ LGPL-3 ) GPL-3"
+SLOT="0"
+KEYWORDS="~amd64"
+IUSE="+docstrings numpy test vulkan"
+REQUIRED_USE="${PYTHON_REQUIRED_USE}"
+
+# Tests fail pretty bad and I'm not fixing them right now
+RESTRICT="test"
+
+# Minimal supported version of Qt.
+QT_PV="$(ver_cut 1-2)*:6"
+
+# Since Clang is required at both build- and runtime, BDEPEND is omitted here.
+LLVM_MAX_SLOT=15
+RDEPEND="${PYTHON_DEPS}
+       =dev-qt/qtbase-${QT_PV}
+       <sys-devel/clang-16:=
+       <sys-devel/clang-runtime-16:=
+       docstrings? (
+               >=dev-libs/libxml2-2.6.32
+               >=dev-libs/libxslt-1.1.19
+       )
+       numpy? ( dev-python/numpy[${PYTHON_USEDEP}] )
+       vulkan? ( dev-util/vulkan-headers )
+"
+DEPEND="${RDEPEND}
+       test? ( =dev-qt/qtbase-${QT_PV}[gui] )
+"
+# testlib is toggled by the gui flag on qtbase
+
+DOCS=( AUTHORS )
+
+PATCHES=(
+       "${FILESDIR}/${PN}-6.3.1-no-strip.patch"
+)
+
+# Ensure the path returned by get_llvm_prefix() contains clang as well.
+llvm_check_deps() {
+       has_version "sys-devel/clang:${LLVM_SLOT}"
+}
+
+src_prepare() {
+       # TODO: File upstream issue requesting a sane way to disable NumPy 
support.
+       if ! use numpy; then
+               sed -i -e '/\bprint(os\.path\.realpath(numpy))/d' \
+                       libshiboken/CMakeLists.txt || die
+       fi
+
+       # Shiboken6 assumes Vulkan headers live under either 
"$VULKAN_SDK/include"
+       # or "$VK_SDK_PATH/include" rather than "${EPREFIX}/usr/include/vulkan".
+       if use vulkan; then
+               sed -i -e 
"s~\bdetectVulkan(&headerPaths);~headerPaths.append(HeaderPath{QByteArrayLiteral(\"${EPREFIX}/usr/include/vulkan\"),
 HeaderType::System});~" \
+                       ApiExtractor/clangparser/compilersupport.cpp || die
+       fi
+
+       # Shiboken6 assumes the 
"/usr/lib/clang/${CLANG_NEWEST_VERSION}/include/"
+       # subdirectory provides Clang builtin includes (e.g., "stddef.h") for 
the
+       # currently installed version of Clang, where ${CLANG_NEWEST_VERSION} is
+       # the largest version specifier that exists under the "/usr/lib/clang/"
+       # subdirectory. This assumption is false in edge cases, including when
+       # users downgrade from newer Clang versions but fail to remove those
+       # versions with "emerge --depclean". See also:
+       #     https://github.com/leycec/raiagent/issues/85
+       #
+       # Sadly, the clang-* family of functions exported by the 
"toolchain-funcs"
+       # eclass are defective, returning nonsensical placeholder strings if the
+       # end user has *NOT* explicitly configured their C++ compiler to be 
Clang.
+       # PySide6 does *NOT* care whether the end user has done so or not, as
+       # PySide6 unconditionally requires Clang in either case. See also:
+       #     https://bugs.gentoo.org/619490
+       sed -i -e 
's~(findClangBuiltInIncludesDir())~(QStringLiteral("'"${EPREFIX}"'/usr/lib/clang/'$(CPP=clang
 clang-fullversion)'/include"))~' \
+               ApiExtractor/clangparser/compilersupport.cpp || die
+
+       cmake_src_prepare
+}
+
+src_configure() {
+       # Minimal tests for now, 2 failing with the extended version
+       # FIXME Subscripted generics cannot be used with class and instance 
checks
+       local mycmakeargs=(
+               -DBUILD_TESTS=$(usex test)
+               -DDISABLE_DOCSTRINGS=$(usex !docstrings)
+       )
+
+       shiboken6_configure() {
+               local mycmakeargs=(
+                       "${mycmakeargs[@]}"
+                       -DPYTHON_CONFIG_SUFFIX="-${EPYTHON}"
+                       -DPYTHON_EXECUTABLE="${PYTHON}"
+                       -DUSE_PYTHON_VERSION="${EPYTHON#python}"
+               )
+               # CMakeLists.txt expects LLVM_INSTALL_DIR as an environment 
variable.
+               local -x LLVM_INSTALL_DIR="$(get_llvm_prefix 
"${LLVM_MAX_SLOT}")"
+               cmake_src_configure
+       }
+       python_foreach_impl shiboken6_configure
+}
+
+src_compile() {
+       python_foreach_impl cmake_src_compile
+}
+
+src_test() {
+       python_foreach_impl cmake_src_test
+}
+
+src_install() {
+       shiboken6_install() {
+               cmake_src_install
+               python_optimize
+
+               # Uniquify the "shiboken6" executable for the current Python 
target,
+               # preserving an unversioned "shiboken6" file arbitrarily 
associated
+               # with the last Python target.
+               cp "${ED}"/usr/bin/${PN}{,-${EPYTHON}} || die
+
+               # Uniquify the Shiboken6 pkgconfig file for the current Python 
target,
+               # preserving an unversioned "shiboken6.pc" file arbitrarily 
associated
+               # with the last Python target. See also:
+               #     https://github.com/leycec/raiagent/issues/73
+               cp "${ED}/usr/$(get_libdir)"/pkgconfig/${PN}{,-${EPYTHON}}.pc 
|| die
+       }
+       python_foreach_impl shiboken6_install
+
+       # CMakeLists.txt installs a "Shiboken6Targets-gentoo.cmake" file forcing
+       # downstream consumers (e.g., PySide6) to target one "libshiboken6-*.so"
+       # library and one "shiboken6" executable linked to one Python 
interpreter.
+       # See also:
+       #     https://bugreports.qt.io/browse/PYSIDE-1053
+       #     https://github.com/leycec/raiagent/issues/74
+       sed -i \
+               -e 
's~shiboken6-python[[:digit:]]\+\.[[:digit:]]\+~shiboken6${PYTHON_CONFIG_SUFFIX}~g'
 \
+               -e 's~/bin/shiboken6~/bin/shiboken6${PYTHON_CONFIG_SUFFIX}~g' \
+               
"${ED}/usr/$(get_libdir)"/cmake/Shiboken6-${PV}/Shiboken6Targets-${CMAKE_BUILD_TYPE,,}.cmake
 || die
+
+       # Remove the broken "shiboken_tool.py" script. By inspection, this 
script
+       # reduces to a noop. Moreover, this script raises the following 
exception:
+       #     FileNotFoundError: [Errno 2] No such file or directory: 
'/usr/bin/../shiboken_tool.py': '/usr/bin/../shiboken_tool.py'
+       rm "${ED}"/usr/bin/shiboken_tool.py || die
+}

Reply via email to